LIBRARY Interception;           // 103
  // DLL raliser en pompant Daniel Drouin et un tuterial sur le site de Michel
USES
  SysUtils, Windows, Messages;

TYPE
  TDonneIntercepter = CLASS
    AdresseIntercepter : HHook;   // Handle la procedure de remplacement
    CopieEcranHandle   : THandle; // Handle du programme Copie Ecran
    Signature          : Integer; // Numero pour reconnaitre le message
                      END;        // qui est destin  Copie Ecran

VAR
  DonneIntercepter : TDonneIntercepter = Nil;
  HookMap : THandle = 0;          // Adresse des donnees afin de pouvoir
                                // lire et crire du programme ou de la Dll

FUNCTION TraitementSpecifique (Code: Integer; Key: WParam;
                               State: LParam): LRESULT;
         stdcall;
BEGIN
  WITH DonneIntercepter DO
  BEGIN
    IF (Code>-1)
        AND (Code=HC_ACTION)      // LParam contient les informations
        AND ((State AND (KF_UP * 32768))>0)  // C'est une prssion sur touche
    THEN BEGIN
      IF CopieEcranHandle<>0    // la DLL est bien initialise
      THEN result := SendMessage(CopieEcranHandle,  // envoie d'un message et
                                 Signature, // attend que le message soit trait
                                 Key,       // code virtuel de la touche
                                 State)    //  information sur la touche
      ELSE
        result := 0;
    END
    ELSE result := CallNextHookEx(AdresseIntercepter, // fonction optionnelle
                                  code, Key, State); // pour que les autres
                                    // applications recoivent la notiofication
  END;
END;

PROCEDURE InstalDllInterception( AdressePgrCopieEcran: HWnd; // handle Copie Ecran
                                 DllSignature : Integer); // Numero du message
          stdcall;
          export;
BEGIN
  WITH DonneIntercepter DO
  BEGIN
    IF (AdresseIntercepter=0)           // DLL pas initialiser
        AND (AdressePgrCopieEcran<>0)   // Handle correcte du Prg Copie Ecran
    THEN BEGIN
      CopieEcranHandle := AdressePgrCopieEcran;
                                                         // valable uniquement
      AdresseIntercepter := SetWindowsHookEx(WH_KEYBOARD, // pour message
                                             TraitementSpecifique, // clavier
                                             HInstance,0); // rediriger vers
      Signature := DllSignature;
    END;
  END;
END;

PROCEDURE DesinstalDllInterception;
          stdcall;
          export;
BEGIN
  IF DonneIntercepter.AdresseIntercepter<>0
  THEN WITH DonneIntercepter DO
    BEGIN
      UnhookWindowsHookEx(AdresseIntercepter); // Enlve le traitement spcificque
      AdresseIntercepter := 0;
    END;
END;

procedure LibraryProc(AReason:Integer);// chaque fois que le point d'entre
BEGIN                                  // de la DLL est appel
  CASE AReason OF
    DLL_PROCESS_ATTACH:BEGIN          // est attach dans la librairie = 1;
      HookMap:=CreateFileMapping($FFFFFFFF, // handle du fichier
                                 nil,  // pointe sur les attributs securits
                                 PAGE_READWRITE, // lecture criture
                                 0, // grosseur du fichier bit haut (* 2 ^ 15)
                                 TDonneIntercepter.InstanceSize, //grosseur bas
                                 'DonneesInterception'); // le nom
                            // initialisation de la vakleur point
      DonneIntercepter:=MapViewOfFile(HookMap, FILE_MAP_WRITE, 0, 0, 0);
    END;
    DLL_PROCESS_DETACH:BEGIN         // est dtach de la librairie = 0;
      UnMapViewOfFile(DonneIntercepter);
      CloseHandle(HookMap);
    END;
    DLL_THREAD_ATTACH: ;
    DLL_THREAD_DETACH: ;
  END;
END;

EXPORTS
 InstalDllInterception name 'InstalDllInterception',
 DesinstalDllInterception name 'DesinstalDllInterception';

begin
  DllProc:=@LibraryProc;  // Pointe sur une procdure dclenche par un point
  LibraryProc(DLL_PROCESS_ATTACH);//  d'entre d'une DLL en initialisant la DLL
end.
